Index: trunk/src/org/apollo/ApolloSystem.java
===================================================================
--- trunk/src/org/apollo/ApolloSystem.java	(revision 1241)
+++ trunk/src/org/apollo/ApolloSystem.java	(revision 1242)
@@ -32,7 +32,7 @@
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.settings.UserSettings;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
+import org.expeditee.settings.UserSettings;
 
 /**
@@ -155,5 +155,5 @@
 		if (profile == null) {
 			try {
-				profile = FrameIO.CreateNewProfile(UserSettings.DEFAULT_PROFILE_NAME);
+				profile = FrameIO.CreateNewProfile(UserSettings.DEFAULT_PROFILE_NAME, null);
 			} catch (Exception e) {
 				e.printStackTrace();
Index: trunk/src/org/expeditee/actions/Misc.java
===================================================================
--- trunk/src/org/expeditee/actions/Misc.java	(revision 1241)
+++ trunk/src/org/expeditee/actions/Misc.java	(revision 1242)
@@ -46,7 +46,5 @@
 import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.gui.AttributeUtils;
-import org.expeditee.io.Conversion;
 import org.expeditee.gui.DisplayController;
-import org.expeditee.io.ExpReader;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -58,4 +56,6 @@
 import org.expeditee.gui.Reminders;
 import org.expeditee.gui.TimeKeeper;
+import org.expeditee.io.Conversion;
+import org.expeditee.io.ExpReader;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
@@ -1334,5 +1334,5 @@
 		homeFrame.removeAllItems(homeFrame.getItems());
 		homeFrame.addText(0, 0, "title", null);
-		FrameUtils.CreateDefaultProfile(UserSettings.UserName.get(), homeFrame);
+		FrameUtils.CreateDefaultProfile(UserSettings.UserName.get(), homeFrame, null);
 	}
 	
@@ -1523,6 +1523,5 @@
 	String frameName = frame.getName();
 	    
-	String frameDir = framePath + Conversion.getFramesetName(frameName)
-	    + File.separator;
+	String frameDir = frame.getFramesetPath(); //framePath + Conversion.getFramesetName(frameName) + File.separator;
 	String localFname = Conversion.getFrameNumber(frameName)
 	    + ExpReader.EXTENTION;
Index: trunk/src/org/expeditee/core/Colour.java
===================================================================
--- trunk/src/org/expeditee/core/Colour.java	(revision 1241)
+++ trunk/src/org/expeditee/core/Colour.java	(revision 1242)
@@ -1,3 +1,5 @@
 package org.expeditee.core;
+
+import org.expeditee.items.Text;
 
 /**
@@ -9,5 +11,5 @@
  *
  */
-public class Colour {
+public class Colour implements Representable {
 
 	private short r, g, b, a;
@@ -280,3 +282,10 @@
 		return new Colour(this);
 	}
+
+	@Override
+	public Text generateRepresentation(String content, String frameset) {
+		Text t = new Text(content);
+		t.setColor(this);
+		return t;
+	}
 }
Index: trunk/src/org/expeditee/core/Representable.java
===================================================================
--- trunk/src/org/expeditee/core/Representable.java	(revision 1242)
+++ trunk/src/org/expeditee/core/Representable.java	(revision 1242)
@@ -0,0 +1,7 @@
+package org.expeditee.core;
+
+import org.expeditee.items.Text;
+
+public interface Representable {
+	public Text generateRepresentation(String content, String frameset);
+}
Index: trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java
===================================================================
--- trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java	(revision 1241)
+++ trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java	(revision 1242)
@@ -90,5 +90,5 @@
 		CUT, 
 		DELETE, 
-		DROP_DOWN, // F0 (ESC) (Seems to locate the cursor underneath the current/last item?)
+		DROP_DOWN, // F0 (ESC) (Positions the cursor below the current text item.  Similar to enter in traditional editors.)
 		EXTRACT_ATTRIBUTES, 
 		EXTRUDE, 
@@ -743,5 +743,5 @@
 				RefreshGestureData data = (RefreshGestureData) gesture.getData();
 				if (data.shouldReloadFrameFirst()) {
-					MessageBay.displayMessage("Forced reload before forced refresh");
+					MessageBay.displayMessage("Loaded in data from external edit made my another user.");
 					DisplayController.Reload(DisplayController.TwinFramesSide.LEFT);
 				}
Index: trunk/src/org/expeditee/gui/Browser.java
===================================================================
--- trunk/src/org/expeditee/gui/Browser.java	(revision 1241)
+++ trunk/src/org/expeditee/gui/Browser.java	(revision 1242)
@@ -536,11 +536,10 @@
 	}
 
-	protected static Frame loadProfile(String userName)
-	{
+	protected static Frame loadProfile(String userName)	{
 		Frame profile = FrameIO.LoadProfile(userName);
 		
 		if (profile == null) {
 			try {
-				profile = FrameIO.CreateNewProfile(userName);
+				profile = FrameIO.CreateNewProfile(userName, null);
 			} catch (Exception e) {
 				// TODO tell the user that there was a problem creating the
Index: trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- trunk/src/org/expeditee/gui/Frame.java	(revision 1241)
+++ trunk/src/org/expeditee/gui/Frame.java	(revision 1242)
@@ -19,4 +19,5 @@
 package org.expeditee.gui;
 
+import java.io.File;
 import java.sql.Time;
 import java.util.ArrayList;
@@ -35,8 +36,14 @@
 import org.expeditee.core.Image;
 import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.Gesture;
+import org.expeditee.gio.gesture.Gesture.GestureType;
 import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.gesture.StandardGestureActions.StandardGestureType;
+import org.expeditee.gio.gesture.data.RefreshGestureData;
 import org.expeditee.gio.input.KBMInputEvent.Key;
 import org.expeditee.gio.input.StandardInputEventListeners;
 import org.expeditee.io.Conversion;
+import org.expeditee.io.ExpReader;
 import org.expeditee.items.Constraint;
 import org.expeditee.items.Dot;
@@ -132,4 +139,7 @@
 	// for drawing purposes
 	private List<Widget> _iWidgets = new ArrayList<Widget>();
+	
+	// frame data
+	private Item frameData = new Text("Frame Data");
 
 	private int _lineCount = 0;
@@ -167,6 +177,5 @@
 
 	/** Default constructor, nothing is set. */
-	public Frame()
-	{
+	public Frame() {
 	}
 
@@ -292,6 +301,5 @@
 	 *            true if the frame should be recalculated first.
 	 */
-	public void notifyObservers(boolean bRecalculate)
-	{
+	public void notifyObservers(boolean bRecalculate) {
 		if (bRecalculate) {
 			recalculate();
@@ -1799,6 +1807,20 @@
 	 * @return The newly created Text Item
 	 */
-	public Text createBlankText(String templateType)
-	{
+	public Text createBlankText(String templateType) {
+		File file = new File(getFramePathReal());
+		long fileLastModified = file.lastModified();
+		long frameLastModified = this.getLastModifyPrecise();
+		//if (ExpReader.getVersion(getFramePathReal()) > this._version) {
+		if (fileLastModified > frameLastModified) {
+			GestureType refreshGestureType = StandardGestureActions.getInstance().gestureType(StandardGestureType.REFRESH);
+			RefreshGestureData refreshGestureData = new RefreshGestureData(true, false);
+			try {
+				StandardGestureActions.getInstance().onGesture(new Gesture(refreshGestureType, refreshGestureData));
+				EcosystemManager.getMiscManager().beep();
+			} catch (NullPointerException e) {
+				//Detected more recent data on file system than on Frame in memory.  Unfortunately not in a position to cause a refresh.
+			}
+		}
+		
 		SessionStats.CreatedText();
 		Text t;
@@ -1834,7 +1856,66 @@
 		return t;
 	}
-
-	public Item createDot()
-	{
+	
+	/**
+	 * Returns the data associated with the frame.
+	 * @return
+	 */
+	public List<String> getData() {
+		return frameData.getData();
+	}
+	
+	/**
+	 * Adds a piece of data to be associated with the frame.
+	 * @param dataItem
+	 */
+	public void addToData(String dataItem) {
+		frameData.addToData(dataItem);
+	}
+
+	/**
+	 * Returns the path (String) to the .exp file that this Frame represents.
+	 * This follows redirects, meaning that it provides the actual file from which 
+	 * the frames data is drawn from.
+	 * @return The path to the .exp file that this Frame represents
+	 * @see getFramePathLogical
+	 * @see getFramesetPath
+	 */
+	public String getFramePathReal() {
+		String framesetPath = getFramesetPath();
+		String redirect = ExpReader.redirectTo(getFramePathLogical());
+		
+		if (redirect == null) {
+			return getFramePathLogical();
+		}
+		
+		while (redirect != null) {
+			framesetPath = getFramesetPath() + redirect;
+			redirect = ExpReader.redirectTo(redirect);
+		}
+		return framesetPath;
+	}
+
+	/**
+	 * Returns the path (String) to the .exp file that this Frame represents.
+	 * Does not follow redirects, opting to instead provide the logical path to this file.
+	 * @return The path to the .exp file that this Frame represents
+	 * @see getFramePathReal
+	 * @see getFramesetPath
+	 */
+	public String getFramePathLogical() {
+		return getFramesetPath() + this.getNumber() + ExpReader.EXTENTION;
+	}
+
+	/**
+	 * Returns the path (String) to the frameset directory that the file that this Frame represents is contained within.
+	 * @return The path to this Frames frameset directory
+	 * @see getFramesetPathLogical
+	 * @see getFramesetPathReal
+	 */
+	public String getFramesetPath() {
+		return this.getPath() + File.separator + this.getFramesetName() + File.separator;
+	}
+
+	public Item createDot()	{
 		Item dot = new Dot(DisplayController.getMouseX(), DisplayController.getMouseY(), getNextItemID());
 
@@ -2462,4 +2543,5 @@
 	{
 		Collection<Item> allItems = new LinkedHashSet<Item>(_body);
+		
 		allItems.addAll(_overlayItems);
 		allItems.addAll(_vectorItems);
Index: trunk/src/org/expeditee/gui/FrameIO.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameIO.java	(revision 1241)
+++ trunk/src/org/expeditee/gui/FrameIO.java	(revision 1242)
@@ -33,16 +33,22 @@
 import java.io.Writer;
 import java.nio.channels.FileChannel;
+import java.nio.file.Paths;
 import java.sql.Time;
+import java.util.Arrays;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
 
 import org.expeditee.actions.Actions;
 import org.expeditee.agents.ExistingFramesetException;
+import org.expeditee.agents.InvalidFramesetNameException;
 import org.expeditee.auth.Authenticator;
 import org.expeditee.auth.EncryptedExpReader;
 import org.expeditee.auth.EncryptedExpWriter;
 import org.expeditee.auth.gui.MailBay;
+import org.expeditee.gio.EcosystemManager;
 import org.expeditee.io.Conversion;
 import org.expeditee.io.ExpReader;
@@ -59,4 +65,5 @@
 import org.expeditee.items.UserAppliedPermission;
 import org.expeditee.network.FrameShare;
+import org.expeditee.setting.Setting;
 import org.expeditee.settings.UserSettings;
 import org.expeditee.settings.folders.FolderSettings;
@@ -79,78 +86,94 @@
 
 	public static void changeParentFolder(String newFolder) {
+		// Partial Paths.
 		PARENT_FOLDER = newFolder;
+		String resourcesPublicPath = PARENT_FOLDER + "resources-public" + File.separator;
+		String resourcesPrivateIndividualPath = PARENT_FOLDER + "resources-" + UserSettings.UserName.get() + File.separator;
+		
+		// Standard paths.
 		PUBLIC_PATH = PARENT_FOLDER + "public" + File.separator;
-		FRAME_PATH = PARENT_FOLDER + "framesets" + File.separator;
 		MESSAGES_PATH = PARENT_FOLDER + "messages" + File.separator;
 		TRASH_PATH = PARENT_FOLDER + "trash" + File.separator;
-		IMAGES_PATH = PARENT_FOLDER + IMAGES_FOLDER;
 		HELP_PATH = PARENT_FOLDER + "documentation" + File.separator;
-		DICT_PATH = PARENT_FOLDER + "dict" + File.separator;
-		FONT_PATH = PARENT_FOLDER + "fonts" + File.separator;
 		PROFILE_PATH = PARENT_FOLDER + "profiles" + File.separator;
 		EXPORTS_DIR = PARENT_FOLDER + "exports" + File.separator;
 		STATISTICS_DIR = PARENT_FOLDER + "statistics" + File.separator;
 		LOGS_DIR = PARENT_FOLDER + "logs" + File.separator;
-		SHARED_BY_ME_FRAMESETS = PARENT_FOLDER + "framesets-shared-by-me" + File.separator;
-		SHARED_WITH_ME_FRAMESETS = PARENT_FOLDER + "framesets-shared-with-me" + File.separator;
-	}
-
-	/**
-	 * The default location for storing the framesets. Each frameset has its own
-	 * subdirectory in this directory.
-	 */
-	public static String IMAGES_FOLDER = "images" + File.separator;
-
+				
+		// New regime paths.
+		if (UserSettings.multiUserMode) {
+			SHARED_FRAMESETS_PATH = resourcesPrivateIndividualPath + "framesets-shared" + File.separator;
+			RESOURCES_PRIVATE = PARENT_FOLDER + "resources-private" + File.separator;
+			RESOURCES_PATH = resourcesPublicPath + "documentation" + File.separator;
+			FRAME_PRIVATE_PATH = resourcesPrivateIndividualPath + "framesets" + File.separator;
+			IMAGES_PRIVATE_PATH = resourcesPrivateIndividualPath + "images" + File.separator;
+			CONTACTS_PATH = resourcesPrivateIndividualPath + "contacts" + File.separator;
+		} else {
+			// If we are using the old regime then these paths should not be used.
+			SHARED_FRAMESETS_PATH = null;
+			RESOURCES_PRIVATE = null;		
+			RESOURCES_PATH = null;
+			FRAME_PRIVATE_PATH = null;
+			IMAGES_PRIVATE_PATH = null;
+			CONTACTS_PATH = null;
+		}
+		
+		// Conditional paths
+		if (UserSettings.multiUserMode) {
+			FONT_PATH = resourcesPublicPath + "fonts" + File.separator;
+			DICT_PATH = resourcesPublicPath + "dict" + File.separator;
+			IMAGES_PATH = resourcesPublicPath + "images" + File.separator;
+			FRAME_PATH = resourcesPublicPath + "framesets" + File.separator;
+		} else {
+			FONT_PATH = PARENT_FOLDER + "fonts" + File.separator;
+			DICT_PATH = PARENT_FOLDER + "dict" + File.separator;
+			IMAGES_PATH = PARENT_FOLDER + "images" + File.separator;
+			FRAME_PATH = PARENT_FOLDER + "framesets" + File.separator;
+		}
+	}
+
+	// The parent path that all others are relative to.  Also referred to as Expeditee Home.
+	public static String PARENT_FOLDER;
+	
+	// The below paths are categorised based on their use in the new/old regime.  See UserSettings.appendDefaultFolders for more inforamtion.
+	// Paths used by Both the new regime (multiuser mode) and the old regime.
+	public static String PROFILE_PATH;
+	public static String FRAME_PATH;
+	public static String MESSAGES_PATH;
+	public static String IMAGES_PATH;
+	public static String PUBLIC_PATH;
 	public static String TRASH_PATH;
-
-	public static String PARENT_FOLDER;
-
-	public static String FRAME_PATH;
-
-	public static String MESSAGES_PATH;
-
-	public static String PUBLIC_PATH;
-
-	public static String IMAGES_PATH;
-
+	
+	// Paths used by both the new regime and the old regime, that points to different locations based on regime setting.
+	public static String FONT_PATH;
+	public static String DICT_PATH;
+	public static String EXPORTS_DIR;
+	public static String STATISTICS_DIR;
+	public static String LOGS_DIR;
+	
+	// Paths used only by new regime.
+	public static String SHARED_FRAMESETS_PATH;
+	public static String CONTACTS_PATH;
+	public static String RESOURCES_PRIVATE;
+	public static String RESOURCES_PATH;
+	public static String FRAME_PRIVATE_PATH;
+	public static String IMAGES_PRIVATE_PATH;
+	
+	// Paths used only by old regime.
 	public static String HELP_PATH;
-
-	public static String FONT_PATH;
 	
+	// Paths that appear to be unused.
 	public static String TEMPLATES_PATH;
+			
+	// Variables for controlling cache functionality.
+	public static final int MAX_NAME_LENGTH = 64;
+	public static final int MAX_CACHE = 100;
+	private static HashMap<String, Frame> _Cache = new FrameCache();
+	private static boolean ENABLE_CACHE = true;
+	private static boolean _UseCache = true;
+	private static boolean _SuspendedCache = false;
 	
-	public static String DICT_PATH;
-
-	public static String PROFILE_PATH;
-
-	public static String EXPORTS_DIR;
-
-	public static String STATISTICS_DIR;
+	private static final String INF_FILENAME = "frame.inf";
 	
-	public static String SHARED_BY_ME_FRAMESETS;
-	
-	public static String SHARED_WITH_ME_FRAMESETS;
-
-	public static String LOGS_DIR;
-
-	private static final String INF_FILENAME = "frame.inf";
-
-	public static final String ILLEGAL_CHARS = ";:\\/?";
-
-	public static final int MAX_NAME_LENGTH = 64;
-
-	public static final int MAX_CACHE = 100;
-
-	private static HashMap<String, Frame> _Cache = new FrameCache();
-
-	// private static HashMap<String, String> _FramesetNameCache = new
-	// HashMap<String, String>();
-
-	private static boolean ENABLE_CACHE = true;
-
-	private static boolean _UseCache = true;
-
-	private static boolean _SuspendedCache = false;
-
 	// All methods are static, this should not be instantiated
 	private FrameIO() {
@@ -202,6 +225,20 @@
 	}
 	
+	/**
+	 * Loads a frame with the specified name.  
+	 * By using a dot separated framename, users are able to specify the path to find the frameset in.
+	 * @param frameName The frame to load.
+	 * @return the loaded frame
+	 */
 	public static Frame LoadFrame(String frameName) {
-		return LoadFrame(frameName, null, false);
+		if (frameName.contains(".")) {
+			String[] split = frameName.split("\\.");
+			String[] pathSplit = Arrays.copyOfRange(split, 0, split.length - 1);
+			String name = split[split.length - 1];
+			String path = Arrays.asList(pathSplit).stream().collect(Collectors.joining(File.separator));
+			return LoadFrame(name, Paths.get(FrameIO.PARENT_FOLDER).resolve(path).toString() + File.separator, false);
+		} else {
+			return LoadFrame(frameName, null, false); //framesets-bryce.home1
+		}
 	}
 
@@ -214,5 +251,5 @@
 			return null;
 		}
-
+		
 		String frameNameLower = frameName.toLowerCase();
 		// first try reading from cache
@@ -221,8 +258,8 @@
 			Frame frame = _Cache.get(frameNameLower);
 			
-			// if frame is cache is older than the one on disk then don't use the cached one
-			String p = frame.getPath() + frame.getNumber() + ".exp";
-			File file = new File(p);
-			if (file.lastModified() <= frame.getLastModifyPrecise()) {
+			// if frame in cache is older than the one on disk then don't use the cached one
+			File file = new File(frame.getFramePathReal());
+			long lastModified = file.lastModified();
+			if (lastModified <= frame.getLastModifyPrecise()) {
 				return frame;
 			}
@@ -232,5 +269,6 @@
 				+ " from disk.");
 
-		return LoadFromDisk(frameName, path, ignoreAnnotations);
+		Frame fromDisk = LoadFromDisk(frameName, path, ignoreAnnotations);
+		return fromDisk;
 	}
 
@@ -250,15 +288,15 @@
 		
 		try{
-				FileInputStream source_fis = new FileInputStream(source);
-				inputChannel = source_fis.getChannel();
+			FileInputStream source_fis = new FileInputStream(source);
+			inputChannel = source_fis.getChannel();
+			
+			FileOutputStream dest_fos = new FileOutputStream(dest);
+			outputChannel = dest_fos.getChannel();
 				
-				FileOutputStream dest_fos = new FileOutputStream(dest);
-				outputChannel = dest_fos.getChannel();
-				
-				outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
-				inputChannel.close();
-				outputChannel.close();
-				source_fis.close();
-				dest_fos.close();
+			outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
+			inputChannel.close();
+			outputChannel.close();
+			source_fis.close();
+			dest_fos.close();
 		}		 
 		catch(Exception e){	
@@ -301,9 +339,9 @@
 
 		if (knownPath != null) {
-			loaded = LoadKnowPath(knownPath, framename);
+			loaded = LoadKnownPath(knownPath, framename);
 		} else {
 			List<String> directoriesToSearch = FolderSettings.FrameDirs.get();
 			
-			if (UserSettings.Authenticated.get()) {
+			if (Authenticator.Authenticated) {
 				// if we are running Expeditee Authenticated, consult user profile as location for framesets first
 				String profilePath = FrameIO.PROFILE_PATH + UserSettings.UserName.get() + File.separator;
@@ -312,5 +350,5 @@
 			
 			for (String path : directoriesToSearch) {
-				loaded = LoadKnowPath(path, framename);
+				loaded = LoadKnownPath(path, framename);
 				if (loaded != null) {
 					break;
@@ -325,4 +363,5 @@
 		if (loaded != null) {
 			FrameUtils.Parse(loaded, true, ignoreAnnotations);
+			FrameIO.setSavedProperties(loaded);
 		}
 
@@ -357,5 +396,5 @@
 	/**
 	 * Gets the full path and file name of the frame.
-	 * 
+	 * This is a alias for Frame::getFramePathLogical
 	 * @param path-
 	 *            the directory in which to look for the frameset containing the
@@ -475,5 +514,5 @@
 	}
 
-	private static Frame LoadKnowPath(String path, String frameName) {
+	private static Frame LoadKnownPath(String path, String frameName) {
 		String fullPath = getFrameFullPathName(path, frameName);
 		if (fullPath == null) {
@@ -483,9 +522,26 @@
 		try {
 			FrameReader reader;
-
+			
+			// Get the frameset name.
+			int i = frameName.length() - 1;
+			for (; i >= 0; i--) {
+				if (!Character.isDigit(frameName.charAt(i))) {
+					break;
+				}	
+			}
+			if (i < 0) {
+				System.err.println("LoadKnownFrame was provided with a invalid Frame name: " + frameName);
+				return null;
+			}
+			String framesetName = frameName.substring(0, i + 1);
+			
+			String redirectTo = ExpReader.redirectTo(fullPath);
+			while (redirectTo != null) {
+				fullPath = path + framesetName + File.separator + redirectTo;
+				redirectTo = ExpReader.redirectTo(fullPath);
+			}
+			
 			if (fullPath.endsWith(ExpReader.EXTENTION)) {
 				if (EncryptedExpReader.isEncryptedExpediteeFile(fullPath)) {
-					//final boolean isProfile = frameName.startsWith(UserSettings.UserName.get());
-					//reader = new EncryptedExpReader(frameName, isProfile);
 					reader = new EncryptedExpReader(frameName);
 				} else {
@@ -919,5 +975,5 @@
 
 	private static boolean isValidFrameNameChar(char c) {
-		return Character.isLetterOrDigit(c) || c == '-';
+		return c == '-' || c == '.' || Character.isLetterOrDigit(c);
 	}
 
@@ -952,17 +1008,14 @@
 	 * 
 	 * @param toSave
-	 *            The Frame to save to disk
+	 *            	The Frame to save to disk
 	 * @param inc
-	 *            True if the saved frames counter should be incremented, false
-	 *            otherwise.
+	 *            	True if the saved frames counter should be incremented, false otherwise.
 	 * @param checkBackup
-	 *            True if the frame should be checked for the back up tag
-	 */
-	public static String SaveFrame(Frame toSave, boolean inc,
-			boolean checkBackup) {
-
+	 *            	True if the frame should be checked for the back up tag
+	 */
+	public static String SaveFrame(Frame toSave, boolean inc, boolean checkBackup) {
 		// TODO When loading a frame maybe append onto the event history too-
 		// with a break to indicate the end of a session
-
+		
 		if (toSave == null || !toSave.hasChanged() || toSave.isSaved()) {
 			return "";
@@ -982,5 +1035,4 @@
 
 		// Save frame that is not local through the Networking classes
-		// TODO
 		if (!toSave.isLocal()) {
 			return FrameShare.getInstance().saveFrame(toSave);
@@ -1012,7 +1064,6 @@
 		try {
 			// if its a new frame or an existing Exp frame...
-			if (fullPath == null || fullPath.endsWith(ExpReader.EXTENTION)) {
-				if (UserSettings.Authenticated.get() && 
-						toSave.getNumber() != Authenticator.PUBLIC_KEY_FRAME && 
+			if (fullPath == null || fullPath.endsWith(ExpReader.EXTENTION)) {				
+				if (toSave.getNumber() != Authenticator.CREDENTIALS_FRAME && 
 						toSave.getEncryptionLabel() != null) {
 					writer = new EncryptedExpWriter(toSave.getEncryptionLabel());
@@ -1022,4 +1073,12 @@
 					savedVersion = ExpReader.getVersion(fullPath);
 				}
+				
+				// Is the file this would be saved to a redirect?
+				String redirectTo = ExpReader.redirectTo(fullPath);
+				if (redirectTo != null) {
+					String redirectedPath = toSave.getFramePathReal();
+					writer.setOutputLocation(redirectedPath);
+				}
+				
 			} else {
 				writer = new KMSWriter();
@@ -1042,11 +1101,12 @@
 			// Check if we are trying to save an out of date version
 			String framesetName = toSave.getFramesetName();
-			long frameLastModify = toSave.getLastModifyPrecise();
-			long fileLastModify = new File(fullPath).lastModified();
-			boolean versionConflict = frameLastModify < fileLastModify;
 			boolean isBayFrameset = 
 					framesetName.equalsIgnoreCase(MessageBay.MESSAGES_FRAMESET_NAME) || 
 					framesetName.equalsIgnoreCase(MailBay.EXPEDITEE_MAIL_FRAMESET_NAME);
-			if ((savedVersion > toSave.getVersion() || versionConflict) && !isBayFrameset) {
+			long frameLastModify = toSave.getLastModifyPrecise();
+			long fileLastModify = new File(toSave.getFramePathReal()).lastModified();
+			boolean fileModifyConflict = fileLastModify > frameLastModify && !isBayFrameset;
+			boolean versionConflict = savedVersion > toSave.getVersion() && !isBayFrameset;
+			if (fileModifyConflict || versionConflict) {
 				// remove this frame from the cache if it is there
 				// This will make sure links to the original are set correctly
@@ -1063,6 +1123,13 @@
 				Text originalMessage = new Text(-1);
 				originalMessage.setColor(MessageBay.ERROR_COLOR);
-				originalMessage.setText(original.getName()
-						+ " was updated by another user.");
+				StringBuilder message = new StringBuilder(original.getName()
+						+ " was updated by another user. ");
+				if (fileModifyConflict) {
+					message.append("{ File modify conflict }");
+				}
+				if (versionConflict) {
+					message.append("{ Version conflict }");
+				}
+				originalMessage.setText(message.toString());
 				originalMessage.setLink(original.getName());
 				Text yourMessage = new Text(-1);
@@ -1073,4 +1140,5 @@
 				MessageBay.displayMessage(originalMessage);
 				MessageBay.displayMessage(yourMessage);
+				EcosystemManager.getMiscManager().beep();
 			} else if (checkBackup
 					&& ItemUtils.ContainsExactTag(toSave.getItems(),
@@ -1112,13 +1180,16 @@
 				ResumeCache();
 			}
-			// Update general stuff about frame
-			setSavedProperties(toSave);
 
 			// int oldMode = FrameGraphics.getMode();
 			// if (oldMode != FrameGraphics.MODE_XRAY)
 			// FrameGraphics.setMode(FrameGraphics.MODE_XRAY, true);
+			
 			writer.writeFrame(toSave);
 			// FrameGraphics.setMode(oldMode, true);
 			toSave.setSaved();
+			
+			// Update general stuff about frame
+			setSavedProperties(toSave);
+			
 			if (inc) {
 				SessionStats.SavedFrame(toSave.getName());
@@ -1144,6 +1215,5 @@
 			// re-parsing)
 			if (isProfileFrame(toSave)) {
-				Frame profile = FrameIO.LoadFrame(toSave.getFramesetName()
-						+ "1");
+				Frame profile = FrameIO.LoadFrame(toSave.getFramesetName() + "1");
 				assert (profile != null);
 				FrameUtils.ParseProfile(profile);
@@ -1155,4 +1225,5 @@
 			return null;
 		}
+		toSave.notifyObservers(false);
 
 		return writer.getFileContents();
@@ -1212,4 +1283,8 @@
 		_Cache.put(toAdd.getName().toLowerCase(), toAdd);
 	}
+	
+	public static void ClearCache() {
+		_Cache.clear();
+	}
 
 	/**
@@ -1241,7 +1316,7 @@
 	}
 
-	public static Frame CreateNewProfile(String username) throws Exception {
+	public static Frame CreateNewProfile(String username, Map<String, Setting> initialSettings) throws InvalidFramesetNameException, ExistingFramesetException  {
 		Frame profile = CreateFrameset(username, PROFILE_PATH, true);
-		FrameUtils.CreateDefaultProfile(username, profile);
+		FrameUtils.CreateDefaultProfile(username, profile, initialSettings);
 		return profile;
 	}
@@ -1477,10 +1552,9 @@
 	}
 
-	public static Frame CreateFrameset(String frameset, String path, boolean recreate) throws Exception
-	{
+	public static Frame CreateFrameset(String frameset, String path, boolean recreate) throws InvalidFramesetNameException, ExistingFramesetException {
 		String conversion = frameset + " --> ";
 
 		if (!isValidFramesetName(frameset)) {
-			throw new Exception("Invalid frameset name");
+			throw new InvalidFramesetNameException(frameset);
 		}
 
@@ -1557,4 +1631,6 @@
 		base.setOwner(UserSettings.UserName.get());
 		SaveFrame(base, true);
+		
+		FrameIO.setSavedProperties(base);
 
 		Logger.Log(Logger.SYSTEM, Logger.NEW_FRAMESET, "Created new frameset: " + frameset);
@@ -1801,12 +1877,4 @@
 			e.printStackTrace();
 		}
-		// } else {
-		//			
-		//			
-		//			
-		// MessageBay
-		// .errorMessage("Recieved save request for unknown public frame: "
-		// + frameName);
-		// }
 	}
 
@@ -1822,4 +1890,3 @@
 		toSave.setActiveTime(activeTime);
 	}
-
 }
